// Author: Hugo Pointcheval
// Email: git@pcl.ovh
// -----
// File: home_page.dart
// Created Date: 19/08/2022 14:38:24
// Last Modified: Wed Nov 09 2022
// -----
// Copyright (c) 2022

import 'package:example_router/presentation/features/sub/sub_page.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:go_router/go_router.dart';
import 'package:wyatt_authentication_bloc/wyatt_authentication_bloc.dart';

class HomePage extends StatelessWidget {
  const HomePage({Key? key}) : super(key: key);

  static String pageName = 'Home';

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Home'),
        actions: [
          IconButton(
              onPressed: () => context.read<AuthenticationCubit<int>>().signOut(),
              icon: const Icon(Icons.logout_rounded))
        ],
      ),
      body: Padding(
        padding: const EdgeInsets.all(8),
        child: SingleChildScrollView(
          child: Column(
            children: [
              AuthenticationBuilder<int>(
                authenticated: (context, accountWrapper) =>
                    Text('Logged as ${accountWrapper.account?.email} | GeneratedId is ${accountWrapper.data}'),
                unauthenticated: (context) =>
                    const Text('Not logged (unauthenticated)'),
                unknown: (context) => const Text('Not logged (unknown)'),
              ),
              const SizedBox(
                height: 8,
              ),
              ElevatedButton(
                  onPressed: () => context.pushNamed(SubPage.pageName),
                  child: const Text('Go to sub page')),
            ],
          ),
        ),
      ),
    );
  }
}
